"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var SingleWaiter_1 = require("./SingleWaiter");
var react_1 = require("react");
var orderFinally_1 = require("./orderFinally");
var Waiter = /** @class */ (function () {
    function Waiter() {
        this._waiters = Object.create(null);
        this.wait = this.wait.bind(this);
        this.useWait = this.useWait.bind(this);
    }
    Waiter.prototype.isWaiting = function (name) {
        return Boolean(this._waiters[name] && this._waiters[name].isWaiting);
    };
    Waiter.prototype._getWaiter = function (name) {
        return this._waiters[name] || (this._waiters[name] = new SingleWaiter_1.default());
    };
    Waiter.prototype.wait = function (name, order) {
        var _this = this;
        var waiter = this._getWaiter(name);
        return orderFinally_1.default(waiter.wait(order), function () {
            if (!waiter.isInUse)
                delete _this._waiters[name];
        });
    };
    Waiter.prototype.useWait = function (name, opts) {
        var _this = this;
        if (opts === void 0) { opts = {}; }
        var waiter = this._getWaiter(name);
        var isWaiting = waiter.useWait(opts);
        react_1.useLayoutEffect(function () { return function () {
            if (!waiter.isInUse)
                delete _this._waiters[name];
        }; }, []);
        return isWaiting;
    };
    return Waiter;
}());
exports.default = Waiter;
